#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK72x72x72NN0x0x0_aX_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=72, NB=72, KB=72, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=6, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const double *stM = A + 72;
   const double *stN = B + (((ldb) << 6)+((ldb) << 3));
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (((lda) << 6)+((lda) << 3)), incAn = -72;
   #define incBk 4
   const int incBm = -72, incBn = (((ldb) << 2)+((ldb) << 1));
   #define incCm 1
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 72;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb), *pB5=pB4+(ldb);
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+56);
      ATL_pfl1R(pfA+64);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC0_4 = *pC4;
         rC0_4 *= rA0;
         rC0_5 = *pC5;
         rC0_5 *= rA0;
         for (k=72; k; k -= 4) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = *pB1;
            rB2 = *pB2;
            rB3 = *pB3;
            rB4 = *pB4;
            rC0_0 += rA0 * rB0;
            rB5 = *pB5;
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[1];
            rB1 = pB1[1];
            rB2 = pB2[1];
            rB3 = pB3[1];
            rB4 = pB4[1];
            rC0_0 += rA0 * rB0;
            rB5 = pB5[1];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[2];
            rB1 = pB1[2];
            rB2 = pB2[2];
            rB3 = pB3[2];
            rB4 = pB4[2];
            rC0_0 += rA0 * rB0;
            rB5 = pB5[2];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            pA0 += incAk;
            rA0 = *pA0;
            rB0 = pB0[3];
            rB1 = pB1[3];
            rB2 = pB2[3];
            rB3 = pB3[3];
            rB4 = pB4[3];
            rC0_0 += rA0 * rB0;
            rB5 = pB5[3];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            pA0 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
            pB4 += incBk;
            pB5 += incBk;
         }
         pA0 -= 0*incAk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC0_5 *= rB0;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
         pB5 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
      pB5 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
