#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK72x72x72TN0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=72, NB=72, KB=72, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=6, ku=72, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const double *stM = A + (((lda) << 6)+((lda) << 3));
   const double *stN = B + (((ldb) << 6)+((ldb) << 3));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 72
   const int incAm = ((lda) - 72), incAn = -(((lda) << 6)+((lda) << 3));
   #define incBk 72
   const int incBm = -72, incBn = (((ldb) << 2)+((ldb) << 1));
   #define incCm 1
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 72;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb), *pB5=pB4+(ldb);
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+56);
      ATL_pfl1R(pfA+64);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC0_4 = *pC4;
         rC0_4 *= rA0;
         rC0_5 = *pC5;
         rC0_5 *= rA0;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = *pB1;
         rB2 = *pB2;
         rB3 = *pB3;
         rB4 = *pB4;
         rC0_0 += rA0 * rB0;
         rB5 = *pB5;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB1[1];
         rB2 = pB2[1];
         rB3 = pB3[1];
         rB4 = pB4[1];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[1];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rB3 = pB3[2];
         rB4 = pB4[2];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[2];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB1[3];
         rB2 = pB2[3];
         rB3 = pB3[3];
         rB4 = pB4[3];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[3];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB1[4];
         rB2 = pB2[4];
         rB3 = pB3[4];
         rB4 = pB4[4];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[4];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rB1 = pB1[5];
         rB2 = pB2[5];
         rB3 = pB3[5];
         rB4 = pB4[5];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[5];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB1[6];
         rB2 = pB2[6];
         rB3 = pB3[6];
         rB4 = pB4[6];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[6];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rB1 = pB1[7];
         rB2 = pB2[7];
         rB3 = pB3[7];
         rB4 = pB4[7];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[7];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rB1 = pB1[8];
         rB2 = pB2[8];
         rB3 = pB3[8];
         rB4 = pB4[8];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[8];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rB1 = pB1[9];
         rB2 = pB2[9];
         rB3 = pB3[9];
         rB4 = pB4[9];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[9];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rB1 = pB1[10];
         rB2 = pB2[10];
         rB3 = pB3[10];
         rB4 = pB4[10];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[10];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rB1 = pB1[11];
         rB2 = pB2[11];
         rB3 = pB3[11];
         rB4 = pB4[11];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[11];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rB1 = pB1[12];
         rB2 = pB2[12];
         rB3 = pB3[12];
         rB4 = pB4[12];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[12];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rB1 = pB1[13];
         rB2 = pB2[13];
         rB3 = pB3[13];
         rB4 = pB4[13];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[13];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rB1 = pB1[14];
         rB2 = pB2[14];
         rB3 = pB3[14];
         rB4 = pB4[14];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[14];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rB1 = pB1[15];
         rB2 = pB2[15];
         rB3 = pB3[15];
         rB4 = pB4[15];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[15];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rB1 = pB1[16];
         rB2 = pB2[16];
         rB3 = pB3[16];
         rB4 = pB4[16];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[16];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rB1 = pB1[17];
         rB2 = pB2[17];
         rB3 = pB3[17];
         rB4 = pB4[17];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[17];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rB1 = pB1[18];
         rB2 = pB2[18];
         rB3 = pB3[18];
         rB4 = pB4[18];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[18];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rB1 = pB1[19];
         rB2 = pB2[19];
         rB3 = pB3[19];
         rB4 = pB4[19];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[19];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rB1 = pB1[20];
         rB2 = pB2[20];
         rB3 = pB3[20];
         rB4 = pB4[20];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[20];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rB1 = pB1[21];
         rB2 = pB2[21];
         rB3 = pB3[21];
         rB4 = pB4[21];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[21];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rB1 = pB1[22];
         rB2 = pB2[22];
         rB3 = pB3[22];
         rB4 = pB4[22];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[22];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rB1 = pB1[23];
         rB2 = pB2[23];
         rB3 = pB3[23];
         rB4 = pB4[23];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[23];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rB1 = pB1[24];
         rB2 = pB2[24];
         rB3 = pB3[24];
         rB4 = pB4[24];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[24];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rB1 = pB1[25];
         rB2 = pB2[25];
         rB3 = pB3[25];
         rB4 = pB4[25];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[25];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rB1 = pB1[26];
         rB2 = pB2[26];
         rB3 = pB3[26];
         rB4 = pB4[26];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[26];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rB1 = pB1[27];
         rB2 = pB2[27];
         rB3 = pB3[27];
         rB4 = pB4[27];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[27];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rB1 = pB1[28];
         rB2 = pB2[28];
         rB3 = pB3[28];
         rB4 = pB4[28];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[28];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rB1 = pB1[29];
         rB2 = pB2[29];
         rB3 = pB3[29];
         rB4 = pB4[29];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[29];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rB1 = pB1[30];
         rB2 = pB2[30];
         rB3 = pB3[30];
         rB4 = pB4[30];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[30];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rB1 = pB1[31];
         rB2 = pB2[31];
         rB3 = pB3[31];
         rB4 = pB4[31];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[31];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rB1 = pB1[32];
         rB2 = pB2[32];
         rB3 = pB3[32];
         rB4 = pB4[32];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[32];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rB1 = pB1[33];
         rB2 = pB2[33];
         rB3 = pB3[33];
         rB4 = pB4[33];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[33];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rB1 = pB1[34];
         rB2 = pB2[34];
         rB3 = pB3[34];
         rB4 = pB4[34];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[34];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rB1 = pB1[35];
         rB2 = pB2[35];
         rB3 = pB3[35];
         rB4 = pB4[35];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[35];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rB1 = pB1[36];
         rB2 = pB2[36];
         rB3 = pB3[36];
         rB4 = pB4[36];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[36];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rB1 = pB1[37];
         rB2 = pB2[37];
         rB3 = pB3[37];
         rB4 = pB4[37];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[37];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rB1 = pB1[38];
         rB2 = pB2[38];
         rB3 = pB3[38];
         rB4 = pB4[38];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[38];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rB1 = pB1[39];
         rB2 = pB2[39];
         rB3 = pB3[39];
         rB4 = pB4[39];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[39];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[40];
         rB0 = pB0[40];
         rB1 = pB1[40];
         rB2 = pB2[40];
         rB3 = pB3[40];
         rB4 = pB4[40];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[40];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[41];
         rB0 = pB0[41];
         rB1 = pB1[41];
         rB2 = pB2[41];
         rB3 = pB3[41];
         rB4 = pB4[41];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[41];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[42];
         rB0 = pB0[42];
         rB1 = pB1[42];
         rB2 = pB2[42];
         rB3 = pB3[42];
         rB4 = pB4[42];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[42];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[43];
         rB0 = pB0[43];
         rB1 = pB1[43];
         rB2 = pB2[43];
         rB3 = pB3[43];
         rB4 = pB4[43];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[43];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[44];
         rB0 = pB0[44];
         rB1 = pB1[44];
         rB2 = pB2[44];
         rB3 = pB3[44];
         rB4 = pB4[44];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[44];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[45];
         rB0 = pB0[45];
         rB1 = pB1[45];
         rB2 = pB2[45];
         rB3 = pB3[45];
         rB4 = pB4[45];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[45];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[46];
         rB0 = pB0[46];
         rB1 = pB1[46];
         rB2 = pB2[46];
         rB3 = pB3[46];
         rB4 = pB4[46];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[46];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[47];
         rB0 = pB0[47];
         rB1 = pB1[47];
         rB2 = pB2[47];
         rB3 = pB3[47];
         rB4 = pB4[47];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[47];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[48];
         rB0 = pB0[48];
         rB1 = pB1[48];
         rB2 = pB2[48];
         rB3 = pB3[48];
         rB4 = pB4[48];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[48];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[49];
         rB0 = pB0[49];
         rB1 = pB1[49];
         rB2 = pB2[49];
         rB3 = pB3[49];
         rB4 = pB4[49];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[49];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[50];
         rB0 = pB0[50];
         rB1 = pB1[50];
         rB2 = pB2[50];
         rB3 = pB3[50];
         rB4 = pB4[50];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[50];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[51];
         rB0 = pB0[51];
         rB1 = pB1[51];
         rB2 = pB2[51];
         rB3 = pB3[51];
         rB4 = pB4[51];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[51];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[52];
         rB0 = pB0[52];
         rB1 = pB1[52];
         rB2 = pB2[52];
         rB3 = pB3[52];
         rB4 = pB4[52];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[52];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[53];
         rB0 = pB0[53];
         rB1 = pB1[53];
         rB2 = pB2[53];
         rB3 = pB3[53];
         rB4 = pB4[53];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[53];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[54];
         rB0 = pB0[54];
         rB1 = pB1[54];
         rB2 = pB2[54];
         rB3 = pB3[54];
         rB4 = pB4[54];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[54];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[55];
         rB0 = pB0[55];
         rB1 = pB1[55];
         rB2 = pB2[55];
         rB3 = pB3[55];
         rB4 = pB4[55];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[55];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[56];
         rB0 = pB0[56];
         rB1 = pB1[56];
         rB2 = pB2[56];
         rB3 = pB3[56];
         rB4 = pB4[56];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[56];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[57];
         rB0 = pB0[57];
         rB1 = pB1[57];
         rB2 = pB2[57];
         rB3 = pB3[57];
         rB4 = pB4[57];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[57];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[58];
         rB0 = pB0[58];
         rB1 = pB1[58];
         rB2 = pB2[58];
         rB3 = pB3[58];
         rB4 = pB4[58];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[58];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[59];
         rB0 = pB0[59];
         rB1 = pB1[59];
         rB2 = pB2[59];
         rB3 = pB3[59];
         rB4 = pB4[59];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[59];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[60];
         rB0 = pB0[60];
         rB1 = pB1[60];
         rB2 = pB2[60];
         rB3 = pB3[60];
         rB4 = pB4[60];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[60];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[61];
         rB0 = pB0[61];
         rB1 = pB1[61];
         rB2 = pB2[61];
         rB3 = pB3[61];
         rB4 = pB4[61];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[61];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[62];
         rB0 = pB0[62];
         rB1 = pB1[62];
         rB2 = pB2[62];
         rB3 = pB3[62];
         rB4 = pB4[62];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[62];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[63];
         rB0 = pB0[63];
         rB1 = pB1[63];
         rB2 = pB2[63];
         rB3 = pB3[63];
         rB4 = pB4[63];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[63];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[64];
         rB0 = pB0[64];
         rB1 = pB1[64];
         rB2 = pB2[64];
         rB3 = pB3[64];
         rB4 = pB4[64];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[64];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[65];
         rB0 = pB0[65];
         rB1 = pB1[65];
         rB2 = pB2[65];
         rB3 = pB3[65];
         rB4 = pB4[65];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[65];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[66];
         rB0 = pB0[66];
         rB1 = pB1[66];
         rB2 = pB2[66];
         rB3 = pB3[66];
         rB4 = pB4[66];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[66];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[67];
         rB0 = pB0[67];
         rB1 = pB1[67];
         rB2 = pB2[67];
         rB3 = pB3[67];
         rB4 = pB4[67];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[67];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[68];
         rB0 = pB0[68];
         rB1 = pB1[68];
         rB2 = pB2[68];
         rB3 = pB3[68];
         rB4 = pB4[68];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[68];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[69];
         rB0 = pB0[69];
         rB1 = pB1[69];
         rB2 = pB2[69];
         rB3 = pB3[69];
         rB4 = pB4[69];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[69];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[70];
         rB0 = pB0[70];
         rB1 = pB1[70];
         rB2 = pB2[70];
         rB3 = pB3[70];
         rB4 = pB4[70];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[70];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rA0 = pA0[71];
         rB0 = pB0[71];
         rB1 = pB1[71];
         rB2 = pB2[71];
         rB3 = pB3[71];
         rB4 = pB4[71];
         rC0_0 += rA0 * rB0;
         rB5 = pB5[71];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         pA0 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         pB4 += incBk;
         pB5 += incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC0_5 *= rB0;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
         pB5 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
      pB5 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
