#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x39TN1x1x8_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=39, 
 * lda=39, ldb=39, ldc=0, mu=1, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   #define Mb M
   #define Nb N
   const double *stM = A + (39*(Mb));
   const double *stN = B + (39*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 7, incAn = -(39*(Mb));
   #define incBk 8
   const int incBm = -32, incBn = 39;
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=32; k; k -= 8) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rC0_0 += rA0 * rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x0x39TN39x39x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=39, 
 * lda=39, ldb=39, ldc=0, mu=1, nu=6, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   #define Mb M
   const int Nb = (N/6)*6;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (39*(Mb));
   const double *stN = B + (39*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*6)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 7, incAn = -(39*(Mb));
   #define incBk 8
   const int incBm = -32, incBn = 234;
   #define incCm 1
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC0_5 = *pC5;
            rC0_5 *= rA0;
            for (k=32; k; k -= 8) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[39];
               rB2 = pB0[78];
               rB3 = pB0[117];
               rB4 = pB0[156];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[195];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB0[40];
               rB2 = pB0[79];
               rB3 = pB0[118];
               rB4 = pB0[157];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[196];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB0[41];
               rB2 = pB0[80];
               rB3 = pB0[119];
               rB4 = pB0[158];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[197];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB0[42];
               rB2 = pB0[81];
               rB3 = pB0[120];
               rB4 = pB0[159];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[198];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB0[43];
               rB2 = pB0[82];
               rB3 = pB0[121];
               rB4 = pB0[160];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[199];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB0[44];
               rB2 = pB0[83];
               rB3 = pB0[122];
               rB4 = pB0[161];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[200];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB0[45];
               rB2 = pB0[84];
               rB3 = pB0[123];
               rB4 = pB0[162];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[201];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rB1 = pB0[46];
               rB2 = pB0[85];
               rB3 = pB0[124];
               rB4 = pB0[163];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[202];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
            }
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[39];
            rB2 = pB0[78];
            rB3 = pB0[117];
            rB4 = pB0[156];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[195];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rB1 = pB0[40];
            rB2 = pB0[79];
            rB3 = pB0[118];
            rB4 = pB0[157];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[196];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rB1 = pB0[41];
            rB2 = pB0[80];
            rB3 = pB0[119];
            rB4 = pB0[158];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[197];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rB1 = pB0[42];
            rB2 = pB0[81];
            rB3 = pB0[120];
            rB4 = pB0[159];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[198];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rB1 = pB0[43];
            rB2 = pB0[82];
            rB3 = pB0[121];
            rB4 = pB0[160];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[199];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rB1 = pB0[44];
            rB2 = pB0[83];
            rB3 = pB0[122];
            rB4 = pB0[161];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[200];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rB1 = pB0[45];
            rB2 = pB0[84];
            rB3 = pB0[123];
            rB4 = pB0[162];
            rC0_0 += rA0 * rB0;
            rB5 = pB0[201];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            *pC4 = rC0_4;
            *pC5 = rC0_5;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_dJIK0x0x39TN1x1x8_a1_bX(M, k, 39, alpha, ca, lda, cb + (39*(Nb)), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
