#ifdef ATL_UCLEANN
#define ATL_dJIK72x0x72TN72x72x0_a1_bX ATL_dgpNBmm_bX
#else
#define ATL_dJIK72x0x72TN72x72x0_a1_bX ATL_dpNBmm_bX
#endif

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK72x0x72TN1x1x8_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=72, NB=0, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=1, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   #define Nb N
   const double *stM = A + 5184;
   const double *stN = B + (((Nb) << 6)+((Nb) << 3));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(72*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 0, incAn = -5184;
   #define incBk 8
   const int incBm = -72, incBn = 72;
   #define incCm 1
   const int incCn = (ldc) - 72;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=72; k; k -= 8) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK72x0x72TN72x72x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=72, NB=0, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=1, nu=6, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const int Nb = (N/6)*6;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 5184;
   const double *stN = B + (((Nb) << 6)+((Nb) << 3));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*6)/(72*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 0, incAn = -5184;
   #define incBk 8
   const int incBm = -72, incBn = 432;
   #define incCm 1
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 72;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc);
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4, rB5;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            rC0_5 = *pC5;
            rC0_5 *= rA0;
            for (k=72; k; k -= 8) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[72];
               rB2 = pB0[144];
               rB3 = pB0[216];
               rB4 = pB0[288];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[360];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB0[73];
               rB2 = pB0[145];
               rB3 = pB0[217];
               rB4 = pB0[289];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[361];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB0[74];
               rB2 = pB0[146];
               rB3 = pB0[218];
               rB4 = pB0[290];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[362];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB0[75];
               rB2 = pB0[147];
               rB3 = pB0[219];
               rB4 = pB0[291];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[363];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB0[76];
               rB2 = pB0[148];
               rB3 = pB0[220];
               rB4 = pB0[292];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[364];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB0[77];
               rB2 = pB0[149];
               rB3 = pB0[221];
               rB4 = pB0[293];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[365];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rB1 = pB0[78];
               rB2 = pB0[150];
               rB3 = pB0[222];
               rB4 = pB0[294];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[366];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rB1 = pB0[79];
               rB2 = pB0[151];
               rB3 = pB0[223];
               rB4 = pB0[295];
               rC0_0 += rA0 * rB0;
               rB5 = pB0[367];
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               rC0_5 += rA0 * rB5;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            *pC4 = rC0_4;
            *pC5 = rC0_5;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pC5 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pC5 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_dJIK72x0x72TN1x1x8_a1_bX(72, k, 72, alpha, ca, lda, cb + (((Nb) << 6)+((Nb) << 3)), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
